import type Bull from "bull";

export function getJobInfo(job: Bull.Job, increment = false) {
	const age = Date.now() - job.timestamp;

	const formated =
		age > 60000
			? `${Math.floor(age / 1000 / 60)}m`
			: age > 10000
			  ? `${Math.floor(age / 1000)}s`
			  : `${age}ms`;

	// onActiveとかonCompletedのattemptsMadeがなぜか0始まりなのでインクリメントする
	const currentAttempts = job.attemptsMade + (increment ? 1 : 0);
	const maxAttempts = job.opts ? job.opts.attempts : 0;

	return `id=${job.id} attempts=${currentAttempts}/${maxAttempts} age=${formated}`;
}
